System.register(["lodash", "app/plugins/sdk", "app/core/utils/kbn"], function (exports_1, context_1) {
    "use strict";
    var __extends = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var lodash_1, sdk_1, kbn_1, SSMBlockMapCtrl;
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [
            function (lodash_1_1) {
                lodash_1 = lodash_1_1;
            },
            function (sdk_1_1) {
                sdk_1 = sdk_1_1;
            },
            function (kbn_1_1) {
                kbn_1 = kbn_1_1;
            }
        ],
        execute: function () {
            SSMBlockMapCtrl = /** @class */ (function (_super) {
                __extends(SSMBlockMapCtrl, _super);
                /** @ngInject */
                function SSMBlockMapCtrl($scope, $injector, $location, linkSrv) {
                    var _this = _super.call(this, $scope, $injector) || this;
                    _this.$location = $location;
                    _this.linkSrv = linkSrv;
                    _this.blockCount = 0;
                    // Set and populate defaults
                    _this.panelDefaults = {
                        blockSize: 16 * 1024 * 1024,
                        colors: ['#447EBC', '#C15C17', '#890F02', '#0A437C', '#6D1F62', '#584477', '#B7DBAB', '#F4D598', '#70DBED', '#F9BA8F', '#F29191', '#82B5D8', '#E5A8E2', '#AEA2E0', '#629E51', '#E5AC0E', '#64B0C8', '#E0752D', '#BF1B00', '#0A50A1', '#962D82', '#614D93', '#9AC48A', '#F2C96D', '#65C5DB', '#F9934E', '#EA6460', '#5195CE', '#D683CE', '#806EB7', '#3F6833', '#967302', '#2F575E', '#99440A', '#58140C', '#052B51', '#511749', '#3F2B5B', '#E0F9D7', '#FCEACA', '#CFFAFF', '#F9E2D2', '#FCE2DE', '#BADFF4', '#F9D9F9', '#DEDAF7'],
                        unit: "none",
                        hideSeriesLines: false
                    };
                    lodash_1.default.defaults(_this.panel, _this.panelDefaults);
                    _this.events.on('data-received', _this.onDataReceived.bind(_this));
                    _this.events.on('data-error', _this.onDataError.bind(_this));
                    _this.events.on('data-snapshot-load', _this.onDataReceived.bind(_this));
                    _this.events.on('init-edit-mode', _this.onInitEditMode.bind(_this));
                    return _this;
                }
                SSMBlockMapCtrl.prototype.onInitEditMode = function () {
                    this.addEditorTab('Options', 'public/plugins/ssm-blockmap-panel/editor.html', 2);
                    this.unitFormats = kbn_1.default.getUnitFormats();
                };
                SSMBlockMapCtrl.prototype.onDataError = function (err) {
                    this.onDataReceived([]);
                };
                SSMBlockMapCtrl.prototype.onDataReceived = function (dataList) {
                    this.blockCount = 0;
                    this.extraSeries = [];
                    for (var _i = 0, dataList_1 = dataList; _i < dataList_1.length; _i++) {
                        var data = dataList_1[_i];
                        var lastPoint = lodash_1.default.last(data.datapoints);
                        if (data.type === "table" || !lodash_1.default.isArray(lastPoint))
                            continue;
                        var value = lastPoint[0];
                        var decimalInfo = this.getDecimalsForValue(data.value);
                        this.extraSeries.push({
                            name: data.alias,
                            value: value,
                            text: kbn_1.default.valueFormats[this.panel.format](value, decimalInfo.decimals, decimalInfo.scaledDecimals)
                        });
                    }
                    this.seriesValueTotal = this.extraSeries.reduce(function (a, b) { return a + b.value; }, 0);
                    this.blockCount = this.panel.blockSize > 0 ? Math.ceil(this.seriesValueTotal / this.panel.blockSize) : 0;
                    this.extraSeries.sort(function (s1, s2) { return s1.value > s2.value ? -1 : (s1.value < s2.value ? 1 : 0); });
                    for (var i = 0; i < this.extraSeries.length; i++) {
                        this.extraSeries[i].color = this.panel.colors[i % this.panel.colors.length];
                        this.extraSeries[i].blockCount = this.panel.blockSize > 0 ? Math.ceil(this.extraSeries[i].value / this.panel.blockSize) : 0;
                    }
                    this.render();
                };
                SSMBlockMapCtrl.prototype.link = function (scope, elem, attrs, ctrl) {
                    var panel = ctrl.panel;
                    for (var key in this.panelDefaults) {
                        if (key in panel)
                            this.panel[key] = panel[key];
                    }
                    this.events.on('render', function () {
                        ctrl.renderingCompleted();
                    });
                };
                SSMBlockMapCtrl.prototype.setUnit = function (item) {
                    this.panel.format = item.value;
                };
                SSMBlockMapCtrl.prototype.getDecimalsForValue = function (value) {
                    if (lodash_1.default.isNumber(this.panel.decimals)) {
                        return { decimals: this.panel.decimals, scaledDecimals: null };
                    }
                    var delta = value / 2;
                    var dec = -Math.floor(Math.log(delta) / Math.LN10);
                    var magn = Math.pow(10, -dec), norm = delta / magn, // norm is between 1.0 and 10.0
                    size;
                    if (norm < 1.5) {
                        size = 1;
                    }
                    else if (norm < 3) {
                        size = 2;
                        // special case for 2.5, requires an extra decimal
                        if (norm > 2.25) {
                            size = 2.5;
                            ++dec;
                        }
                    }
                    else if (norm < 7.5) {
                        size = 5;
                    }
                    else {
                        size = 10;
                    }
                    size *= magn;
                    // reduce starting decimals if not needed
                    if (Math.floor(value) === value) {
                        dec = 0;
                    }
                    var result = {};
                    result.decimals = Math.max(0, dec);
                    result.scaledDecimals = result.decimals - Math.floor(Math.log(size) / Math.LN10) + 2;
                    return result;
                };
                SSMBlockMapCtrl.templateUrl = 'ssm-blockmap-panel/module.html';
                SSMBlockMapCtrl.LINE_DIV_WIDTH = 16;
                SSMBlockMapCtrl.SERIES_NAME_DIV_HEIGHT = 24;
                return SSMBlockMapCtrl;
            }(sdk_1.MetricsPanelCtrl));
            exports_1("SSMBlockMapCtrl", SSMBlockMapCtrl);
            exports_1("PanelCtrl", SSMBlockMapCtrl);
        }
    };
});
//# sourceMappingURL=module.js.map