System.register(["lodash", "app/plugins/sdk"], function (exports_1, context_1) {
    "use strict";
    var __extends = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var lodash_1, sdk_1, SSMFilterTableCtrl;
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [
            function (lodash_1_1) {
                lodash_1 = lodash_1_1;
            },
            function (sdk_1_1) {
                sdk_1 = sdk_1_1;
            }
        ],
        execute: function () {
            SSMFilterTableCtrl = /** @class */ (function (_super) {
                __extends(SSMFilterTableCtrl, _super);
                /** @ngInject */
                function SSMFilterTableCtrl($scope, $injector, $location, linkSrv) {
                    var _this = _super.call(this, $scope, $injector) || this;
                    _this.$location = $location;
                    _this.linkSrv = linkSrv;
                    _this.sortColumn = -1;
                    _this.sortDesc = false;
                    // Set and populate defaults
                    _this.panelDefaults = {
                        filterKey: "schema",
                        maxRows: 50,
                        filterIgnore: "mysql,information_schema,performance_schema"
                    };
                    lodash_1.default.defaults(_this.panel, _this.panelDefaults);
                    _this.events.on('data-received', _this.onDataReceived.bind(_this));
                    _this.events.on('data-error', _this.onDataError.bind(_this));
                    _this.events.on('data-snapshot-load', _this.onDataReceived.bind(_this));
                    _this.events.on('init-edit-mode', _this.onInitEditMode.bind(_this));
                    return _this;
                }
                SSMFilterTableCtrl.prototype.onInitEditMode = function () {
                    this.addEditorTab('Options', 'public/plugins/ssm-filtertable-panel/editor.html', 2);
                };
                SSMFilterTableCtrl.prototype.onDataError = function (err) {
                    this.onDataReceived([]);
                };
                SSMFilterTableCtrl.prototype.onDataReceived = function (dataList) {
                    if (!dataList.length || dataList[0].type !== "table") {
                        this.table = null;
                    }
                    else {
                        var data = dataList[0];
                        var filterKeyIndex = -1;
                        var timeKeyIndex = -1;
                        for (var i = 0; i < data.columns.length; i++) {
                            if (data.columns[i].text === this.panel.filterKey)
                                filterKeyIndex = i;
                            if (data.columns[i].text === "Time")
                                timeKeyIndex = i;
                        }
                        // sort column defaults to last column
                        if (this.sortColumn === -1)
                            this.sortColumn = data.columns.length - 1;
                        var filterValueItems_1 = !!this.filterValue ? this.filterValue.split(",").map(function (item) { return item.trim(); }) : [];
                        var ignoreValueItems_1 = !!this.panel.filterIgnore ? this.panel.filterIgnore.split(",").map(function (item) { return item.trim(); }) : [];
                        if (filterKeyIndex !== -1)
                            data.rows = data.rows.filter(function (row) {
                                return !(row.lenght <= filterKeyIndex ||
                                    (filterValueItems_1.length && filterValueItems_1.indexOf(row[filterKeyIndex]) === -1) ||
                                    (ignoreValueItems_1.length && ignoreValueItems_1.indexOf(row[filterKeyIndex]) !== -1));
                            });
                        if (this.panel.maxRows > 0)
                            data.rows = data.rows.slice(0, this.panel.maxRows);
                        timeKeyIndex !== -1 && data.rows.map(function (row) {
                            var d = new Date(row[timeKeyIndex]);
                            row[timeKeyIndex] = d.getFullYear() + "-" + ("0" + (d.getMonth() + 1)).slice(-2) + "-" + ("0" + d.getDate()).slice(-2) + " " + ("0" + d.getHours()).slice(-2) + ":" + ("0" + d.getMinutes()).slice(-2) + ":" + ("0" + d.getSeconds()).slice(-2);
                        });
                        this.table = data;
                        this.sortData();
                    }
                    this.render();
                };
                SSMFilterTableCtrl.prototype.toggleColumnSort = function (col, index) {
                    if (this.sortColumn === index) {
                        this.sortDesc = !this.sortDesc;
                    }
                    else {
                        this.sortColumn = index;
                        this.sortDesc = true;
                    }
                    this.sortData();
                };
                SSMFilterTableCtrl.prototype.sortData = function () {
                    var _this = this;
                    this.sortColumn >= 0 && this.table.rows.sort(function (r1, r2) {
                        if (_this.sortDesc)
                            return r1[_this.sortColumn] < r2[_this.sortColumn] ? 1 : -1;
                        else
                            return r1[_this.sortColumn] > r2[_this.sortColumn] ? 1 : -1;
                    }) && this.render();
                };
                SSMFilterTableCtrl.prototype.link = function (scope, elem, attrs, ctrl) {
                    var panel = ctrl.panel;
                    for (var key in this.panelDefaults) {
                        if (key in panel)
                            this.panel[key] = panel[key];
                    }
                    this.events.on('render', function () {
                        ctrl.renderingCompleted();
                    });
                };
                SSMFilterTableCtrl.templateUrl = 'ssm-filtertable-panel/module.html';
                return SSMFilterTableCtrl;
            }(sdk_1.MetricsPanelCtrl));
            exports_1("SSMFilterTableCtrl", SSMFilterTableCtrl);
            exports_1("PanelCtrl", SSMFilterTableCtrl);
        }
    };
});
//# sourceMappingURL=module.js.map